AV = AV
local L = LibStub("AceLocale-3.0"):GetLocale("AutoVendor")

-----------------------------
-- Register Slash Commands --
-----------------------------
SLASH_RELOADUI1 = "/rl";
SlashCmdList.RELOADUI = ReloadUI;


-----------------------
-- Main Event OnLoad --
-----------------------
function AutoVendorExtended_OnLoad(self)
  AutoVendorExtended_AddReSellButton()
end


----------------
-- Extensions --
----------------
function AutoVendorExtended_AddReSellButton()
  local BtnSellGrey = CreateFrame( "Button" , "ReSellBtn" , MerchantFrame, "UIPanelButtonTemplate" )
  BtnSellGrey:SetText("Re-Sell")
  BtnSellGrey:SetWidth(90)
  BtnSellGrey:SetHeight(21)
  BtnSellGrey:SetPoint("TopRight", -180, -30 )
  BtnSellGrey:RegisterForClicks("AnyUp")
  BtnSellGrey:SetScript("OnClick", function()
    AV:MERCHANT_SHOW()
  end)
end


------------------------------------
-- Overwrite AutoVendor Functions --
------------------------------------
function AV:ToggleJunk(msg, editbox)
  if msg then
    self:ResetJunkCache()

    for itemIdStr in string.gmatch(msg, "item:(%d+)") do
      local itemId = tonumber(itemIdStr)
      local itemName = select(1, GetItemInfo(itemId))

      if itemId and itemName then
        AutoVendorExtended_AVListToggle(self.db.profile.junk, 'junk list', itemId, itemName)
      else
        if msg and AutoVendorExtended_AVListRemove(self.db.profile.junk, msg) then
          self:Print(string.format(L['Removed from list'], msg, 'junk list'))
        else
          self:Print(L['No item link'])
        end
      end
    end
  else
    self:Print(L['No item link'])
  end
end

function AutoVendorExtended_AVListToggle(list, listName, itemId, itemName)
	if list[itemId] then
		list[itemId] = nil
		AV:Print(string.format(L['Removed from list'], itemName, listName))
	else
		table.insert(list, itemId, itemName)
		AV:Print(string.format(L['Added to list'], itemName, listName))
	end
end

function AutoVendorExtended_AVListRemove(list, item)
	found = false
	for k,v in pairs(list) do
		if string.lower(v) == string.lower(item) then
			list[k] = nil
			found = true
		end
	end
	return found
end
